/*
 *	rs3item.h
 *		Copyright (C)2002, 2003 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#ifndef RS3ITEM_H
#define RS3ITEM_H

#include "rs3define.h"

typedef struct tool_tag
{
	int dummy;	/* _~[ */
} tool_t;

typedef struct weapon_tag
{
	int attack_power;	/* U */
	int weight;			/* d */
	int flag_2handed;	/* 莝ł */
	int flag_fixed;		/* Œ葕ł */
	int tech_no[2];		/* ŗLZ̔ԍ */
} weapon_t;

typedef struct shield_tag
{
	int defense_power;	/* h */
	int evade_rate;		/*  */
	int weight;			/* d */
	elem_t regist_elem;	/* h䑮 */
} shield_t;

typedef struct protector_tag
{
	int defense_power;			/* h */
	int magic_defense_power;	/* @h */
	int defense_slash;			/* aȖϐ */
	int defense_knock;			/* ōȖϐ */
	int defense_poke;			/* ˍȖϐ */
	int defense_shoot;			/* ˍȖϐ */
	int defense_fire;			/* MȖϐ */
	int defense_ice;			/* CȖϐ */
	int defense_thunder;		/* Ȗϐ */
	int defense_state;			/* ԕωȖϐ */
	int increase_strength;		/* r͏㏸ */
	int increase_dexterity;		/* p㏸ */
	int increase_speed;			/* f㏸ */
	int increase_stamina;		/* ̗͏㏸ */
	int increase_magic_power;	/* ͏㏸ */
	int increase_will_power;	/* ӎu͏㏸ */
	int increase_charm;			/* ͏㏸ */
	int weight;					/* d */
	int type_healing;			/* 񕜃^Cv */
	state_t regist_state;		/* ԕωւ̑ϐ */
	int flag_regist_water;		/* Uɑ΂ϐ */
	int flag_regist_throw;		/* Uɑ΂ϐ */
	int flag_regist_soundwave;	/* gUɑ΂ϐ */
	int flag_regist_gaze;		/* ÎUɑ΂ϐ */
	int flag_regist_ground;		/* nUɑ΂ϐ */
	int flag_fixed;				/* Œ葕ł */
} protector_t;

union itemparam_t
{
	tool_t tool;			/* 퓬ACef[^ */
	weapon_t weapon;		/* ACef[^ */
	shield_t shield;		/* f[^ */
	protector_t protector;	/* hACef[^ */
};

typedef struct itemdata_tag
{
	int type;					/* ^Cv(ITEM_TYPE_WEAPON`ITEM_TYPE_OTHER) */
	int power;					/* \̍U/h */
	long price;					/* i */
	int message_no;				/* bZ[W̔ԍ */
	union itemparam_t param;	/* ACef[^ */
} itemdata_t;

enum	/* itemdata_t.typep */
{
	ITEM_TYPE_TOOL,			/* 퓬ACe */
	ITEM_TYPE_WEAPON,		/*  */
	ITEM_TYPE_SHIELD,		/*  */
	ITEM_TYPE_PROTECTOR,	/* h */
	ITEM_TYPE_OTHER,		/* ̑ */
	ITEM_TYPE_NUM
};

const char *item_getname(int index);
itemdata_t *item_readdata(void);
int item_writeparam(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeregist(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeeffect(const char *ptr_filename, const itemdata_t *ptr_itemdata);

#endif /* RS3ITEM_H */
